searchNodes=[{"doc":"A server to run Unix shell commands.SetupThe recommended way is to use CommandRunner as part of your application supervision tree.defmodule MyApp.Application do use Application def start(_type, _args) do children = [ {CommandRunner, name: MyApp.CommandRunner} ] Supervisor.start_link( children, strategy: :one_for_one, name: MyApp.Supervisor ) end end","ref":"CommandRunner.html","title":"CommandRunner","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"CommandRunner.html#child_spec/1","title":"CommandRunner.child_spec/1","type":"function"},{"doc":"Determines whether the command with the specified ref is running on the given server.Examplesiex&gt; ref = make_ref() ...&gt; Task.async(fn -&gt; ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;sleep 2&quot;, [], ref) ...&gt; end) ...&gt; CommandRunner.command_running?(MyApp.Runner, ref) true iex&gt; CommandRunner.run_command(MyApp.Runner, &quot;echo &#39;Hey!&#39;&quot;, [], ref) ...&gt; CommandRunner.command_running?(MyApp.Runner, ref) false","ref":"CommandRunner.html#command_running?/2","title":"CommandRunner.command_running?/2","type":"function"},{"doc":"Gets the OS process ID for the command with the specified ref on the given server.Examplesiex&gt; ref = make_ref() ...&gt; Task.async(fn -&gt; ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;sleep 2&quot;, [], ref) ...&gt; end) ...&gt; CommandRunner.os_pid(MyApp.Runner, ref) 6458 iex&gt; CommandRunner.run_command(MyApp.Runner, &quot;echo &#39;Hey!&#39;&quot;, [], ref) nil","ref":"CommandRunner.html#os_pid/2","title":"CommandRunner.os_pid/2","type":"function"},{"doc":"Runs a particular command and returns the exit code and result data.Options:cd - Path to the working directory that the script is executed in.:env - A map containing environment variables that are passed to the command.Examplesiex&gt; CommandRunner.run_command(MyApp.Runner, &quot;echo &#39;Hello World&#39;&quot;) {0, &quot;Hello World\\n&quot;} iex&gt; CommandRunner.run_command(MyApp.Runner, &quot;which foo&quot;) {1, &quot;&quot;}Only one command with the same ref can run in a single command runner process.iex&gt; ref = make_ref() ...&gt; Task.async(fn -&gt; ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;sleep 2&quot;, [], ref) ...&gt; end) ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;echo &#39;Hello&#39;&quot;, [], ref) :runningOther processes may stop a command. The caller is notified about that.iex&gt; ref = make_ref() ...&gt; task = Task.async(fn -&gt; ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;sleep 2&quot;, [], ref) ...&gt; end) ...&gt; CommandRunner.stop_command(MyApp.Runner, ref) ...&gt; Task.await(task) :stopped","ref":"CommandRunner.html#run_command/4","title":"CommandRunner.run_command/4","type":"function"},{"doc":"Starts a command runner.","ref":"CommandRunner.html#start_link/1","title":"CommandRunner.start_link/1","type":"function"},{"doc":"Stops the given command runner and terminates all running commands.","ref":"CommandRunner.html#stop/2","title":"CommandRunner.stop/2","type":"function"},{"doc":"Stops the command with the given ref and brutally kills the associated OS process.Exampleiex&gt; ref = make_ref() ...&gt; Task.async(fn -&gt; ...&gt; CommandRunner.run_command(MyApp.Runner, &quot;sleep 2&quot;, [], ref) ...&gt; end) ...&gt; CommandRunner.stop_command(MyApp.Runner, ref) :ok","ref":"CommandRunner.html#stop_command/2","title":"CommandRunner.stop_command/2","type":"function"},{"doc":"Type describing the command runner server.","ref":"CommandRunner.html#t:server/0","title":"CommandRunner.server/0","type":"type"},{"doc":"CommandRunner An Elixir library providing a simple API to start and stop shell commands.","ref":"readme.html","title":"CommandRunner","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding command_runner to your list of dependencies in mix.exs:def deps do [ {:command_runner, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"CommandRunner - Installation","type":"extras"},{"doc":"Documentation can be generated with ExDoc and found at HexDocs.","ref":"readme.html#documentation","title":"CommandRunner - Documentation","type":"extras"}]